gtkmm: Gtk::EnumList< T > Class Template Reference

gtkmm 4.23.2

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Gtk::EnumList< T > Class Template Reference
ListView Classes

A Gio::ListModel representing values of a given enum. More...

`#include <gtkmm/enumlist.h>`

Inheritance diagram for Gtk::EnumList< T >:
[legend]

## Public Member Functions
unsigned int | find (T value) const
| Finds the position of a given enum value in this EnumList.
Public Member Functions inherited from Gtk::EnumListBase
| EnumListBase (EnumListBase && src) noexcept
EnumListBase & | operator= (EnumListBase && src) noexcept
| ~EnumListBase () noexcept override
GtkEnumList * | gobj ()
| Provides access to the underlying C GObject.
const GtkEnumList * | gobj () const
| Provides access to the underlying C GObject.
GtkEnumList * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
GType | get_enum_type () const
| Gets the type of the enum represented by self.
unsigned int | find (int value) const
| Finds the position of a given enum value in this EnumListBase.
Glib::RefPtr< EnumListItem > | get_item (unsigned int position)
| Get the item at position.
Glib::RefPtr< const EnumListItem > | get_item (unsigned int position) const
| Get the item at position.
Glib::PropertyProxy_ReadOnly< GType > | property_enum_type () const
| The type of the enum represented by the model.
Glib::PropertyProxy_ReadOnly< GType > | property_item_type () const
| The type of the items.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_items () const
| The number of items.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::ListModel
| ListModel (ListModel &&src) noexcept
ListModel & | operator= (ListModel &&src) noexcept
| ~ListModel () noexcept override
GListModel * | gobj ()
const GListModel * | gobj () const
GType | get_item_type () const
guint | get_n_items () const
Glib::RefPtr< Glib::ObjectBase > | get_object (guint position)
Glib::RefPtr< const Glib::ObjectBase > | get_object (guint position) const
Glib::RefPtr< T_item > | get_typed_object (guint position)
Glib::RefPtr< const T_item > | get_typed_object (guint position) const
Glib::SignalProxy< void(guint, guint, guint)> | signal_items_changed ()
Glib::RefPtr< Gio::ListModel > | wrap (GListModel *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static Glib::RefPtr< EnumList > | create ()
| Creates a new Gtk::EnumList<T> for enums to type T.
Static Public Member Functions inherited from Gtk::EnumListBase
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< EnumListBase > | create (GType enum_type)
| Creates a new Gtk::EnumListBase for enum_type.
Static Public Member Functions inherited from Gio::ListModel
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Protected Member Functions
| EnumList ()
Protected Member Functions inherited from Gtk::EnumListBase
| EnumListBase (GType enum_type)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::ListModel
| ListModel ()
void | items_changed (guint position, guint removed, guint added)
virtual GType | get_item_type_vfunc ()
virtual guint | get_n_items_vfunc ()
virtual gpointer | get_item_vfunc (guint position)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Related Symbols inherited from Gtk::EnumListBase
Glib::RefPtr< Gtk::EnumListBase > | wrap (GtkEnumList * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

template<typename T>
class Gtk::EnumList< T >

A Gio::ListModel representing values of a given enum.

Gtk::EnumList contains items of type Gtk::EnumListItem.

A simple way to use a Gtk::EnumList is to populate a Gtk::DropDown widget using the short name (or "nick") of the values of an enumeration type:

Glib::RefPtr<Gtk::EnumList<Gtk::Justification>> enum_list =
Gtk::EnumList<Gtk::Justification>::create();
Glib::RefPtr<Gtk::PropertyExpression> expression =
Gtk::PropertyExpression<Glib::ustring>::create(Gtk::EnumListItem::get_type(), "nick");
Gtk::DropDown* drop_down = Gtk::make_managed<Gtk::DropDown>(enum_list, expression);
Gtk::DropDown
Choose an item from a list.
Definition dropdown.h:74
Gtk::EnumListItem::get_type
static GType get_type()
Get the GType for this class, for use with the underlying GObject type system.
Gtk::EnumList::create
static Glib::RefPtr< EnumList > create()
Creates a new Gtk::EnumList<T> for enums to type T.
Definition enumlist.h:286
Gtk::PropertyExpression::create
static Glib::RefPtr< PropertyExpression > create(GType this_type, const Glib::ustring &property_name)
Creates an expression that looks up a property via the this argument.
Glib::RefPtr
std::shared_ptr< T_CppObject > RefPtr
Gtk::make_managed
auto make_managed(T_Args &&... args)
Create a Gtk::Object such as a widget and Gtk::manage() it in a single step.
Definition object.h:67

All variables in the code snippet can be declared auto. The full types are shown to make it clear what they are.

See also
  Gio::ListModel, Gtk::EnumListItem

Since gtkmm 4.24

Template Parameters

  T | Type of an enum which has been registered in GLib's GType system. It can't be a flags type (such as Gtk::StateFlags).

## Constructor & Destructor Documentation

## ◆ EnumList()

template <typename T>

Gtk::EnumList< T >::EnumList | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create()

template <typename T>

Glib::RefPtr< EnumList< T > > Gtk::EnumList< T >::create | ( |  | ) |
| static

Creates a new Gtk::EnumList<T> for enums to type T.

Since gtkmm 4.24

Returns
  The newly created Gtk::EnumList<T>.

## ◆ find()

template <typename T>

unsigned int Gtk::EnumList< T >::find | ( | T | value | ) | const

Finds the position of a given enum value in this EnumList.

If the value is not found, GTK_INVALID_LIST_POSITION is returned.

Since gtkmm 4.24

Parameters

  value | An enum value.

Returns
  The position of the value.